
#include<stdio.h>
#include"ff.h"
#include"os816.h"




int Ustrncmp(unsigned char *x,unsigned char *y, int count)
{
	int c;
	for(c=0;c<count;c++)
	{ 
        if((x[c]>96) && (x[c]<122))
	 {
	  if((x[c]-32)!=y[c]) return 0;
	 }
	 else
	 {	  		
	  if(x[c]!=y[c]) return 0;
	 }
	}

	return 1;
}


int qputc(char c)
{
	char data;
	  data=c;
  
	asm{     
    		LDA %%data 	;
    		JSL $00FF00 	; 
	}

	return c;
 
}


void qputsn(unsigned char *y,unsigned int count)
{
	unsigned char data;
	int x;

	for(x=0;x<count;x++)
	{ 
	  data=*y++;

	asm {     
    		LDA %%data 	;
    		JSL $00FF00 	; 
	    }
	}
}


int qputs(const char *y)
{
	char data;

	while(*y)
	{ 
	  data=*y++;

	asm{     
    		LDA %%data 	;
    		JSL $00FF00 	; 
	}

	}; 
	return 1;
}

void readstring(unsigned char *y)
{
	int data,count;
	

	data=0;
	count=0;
	while(data!=13) {
		asm{     
    			JSL $00FF08 	; 
	    		and #$00FF 	;
    			sta %%data 	;
		}

		if((data>31) && (data < 127))
		{
			count++;
			*y=data;
			*y++;
			asm{     
    				LDA %%data 	;
    				JSL $00FF00 	; 
			   }
		}

		if((data==8) && (count>0))
		{
			count--;
			*y--;
			asm{     
    				LDA %%data 	;
    				JSL $00FF00 	; 
    				LDA #$0020
				JSL $00FF00 	; 
    				LDA %%data 	;
    				JSL $00FF00 	; 
			   }
		}

	} 
	*y++=0;
}


int qprintf (
	const TCHAR* str,	/* Pointer to the format string */
	...					/* Optional arguments... */
)
{
	va_list arp;
	BYTE f, r;
	UINT i, j, w;
	ULONG v;
	TCHAR c, d, s[16], *p;
	int res, chc, cc;


	va_start(arp, str);

	for (cc = res = 0; cc != EOF; res += cc) {
		c = *str++;
		if (c == 0) break;			/* End of string */
		if (c != '%') {				/* Non escape character */
			cc = qputc(c);  
			if (cc != EOF) cc = 1;
			continue;
		}
		w = f = 0;
		c = *str++;
		if (c == '0') {				/* Flag: '0' padding */
			f = 1; c = *str++;
		} else {
			if (c == '-') {			/* Flag: left justified */
				f = 2; c = *str++;
			}
		}
		while (IsDigit(c)) {		/* Precision */
			w = w * 10 + c - '0';
			c = *str++;
		}
		if (c == 'l' || c == 'L') {	/* Prefix: Size is long int */
			f |= 4; c = *str++;
		}
		if (!c) break;
		d = c;
		if (IsLower(d)) d -= 0x20;
		switch (d) {				/* Type is... */
		case 'S' :					/* String */
			p = va_arg(arp, TCHAR*);
			for (j = 0; p[j]; j++) ;
			chc = 0;
			if (!(f & 2)) {
				while (j++ < w) chc += (cc = qputc(' '));
			}
			chc += (cc = qputs(p));
			while (j++ < w) chc += (cc = qputc(' '));
			if (cc != EOF) cc = chc;
			continue;
		case 'C' :					/* Character */
			cc = qputc((TCHAR)va_arg(arp, int)); continue;
		case 'B' :					/* Binary */
			r = 2; break;
		case 'O' :					/* Octal */
			r = 8; break;
		case 'D' :					/* Signed decimal */
		case 'U' :					/* Unsigned decimal */
			r = 10; break;
		case 'X' :					/* Hexdecimal */
			r = 16; break;
		default:					/* Unknown type (passthrough) */
			cc = qputc(c); continue;
		}

		/* Get an argument and put it in numeral */
		v = (f & 4) ? (ULONG)va_arg(arp, long) : ((d == 'D') ? (ULONG)(long)va_arg(arp, int) : (ULONG)va_arg(arp, unsigned int));
		if (d == 'D' && (v & 0x80000000)) {
			v = 0 - v;
			f |= 8;
		}
		i = 0;
		do {
			d = (TCHAR)(v % r); v /= r;
			if (d > 9) d += (c == 'x') ? 0x27 : 0x07;
			s[i++] = d + '0';
		} while (v && i < sizeof(s) / sizeof(s[0]));
		if (f & 8) s[i++] = '-';
		j = i; d = (f & 1) ? '0' : ' ';
		res = 0;
		while (!(f & 2) && j++ < w) res += (cc = qputc(d));
		do res += (cc = qputc(s[--i])); while(i);
		while (j++ < w) res += (cc = qputc(' '));
		if (cc != EOF) cc = res;
	}

	va_end(arp);
	return (cc == EOF) ? cc : res;
}

