;__OS816Start______________________________________________________________________________________
;
;	Startup Code for OS816 - NATIVE MODE
;
;	WRITTEN BY: DAN WERNER -- 10/24/2017
;
;__________________________________________________________________________________________________
;
; DATA CONSTANTS
;__________________________________________________________________________________________________

		CHIP	65816		; SET CHIP		
		LONGA	OFF		; ASSUME EMULATION MODE			
		LONGI	OFF		;
		PW	128
		PL 	60
		INCLIST ON

		EXTERN ~~main
		EXTERN ~~API_DISPATCH

STACK 		EQU 	$7FFF 		;CHANGE THIS FOR YOUR SYSTEM

START:
		JML	DOSTART
API:
		JML	~~API_DISPATCH
DOSTART:
		CLC 			;clear carry
		XCE 			;clear emulation
		REP 	#$30 		;16 bit registers
		LONGI ON
		LONGA ON
		LDA 	#STACK 		;get the stack address
		TCS 			;and set the stack to it 

		JML	~~main

